(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     11419,        374]
NotebookOptionsPosition[     10119,        325]
NotebookOutlinePosition[     10537,        343]
CellTagsIndexPosition[     10494,        340]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Towers of Hanoi (Problem 4.6)", "Section",
 CellChangeTimes->{{3.592307577481009*^9, 3.592307581971336*^9}, 
   3.592307663411476*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"otherPeg", "[", 
    RowBox[{"A", ",", "B"}], "]"}], ":=", "C"}], ";", " ", 
  RowBox[{
   RowBox[{"otherPeg", "[", 
    RowBox[{"B", ",", "A"}], "]"}], " ", ":=", " ", "C"}]}]], "Input",
 CellChangeTimes->{{3.592299081177256*^9, 3.5922990903519917`*^9}, {
  3.592307523262279*^9, 3.592307526355855*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"otherPeg", "[", 
    RowBox[{"B", ",", "C"}], "]"}], ":=", "A"}], ";", " ", 
  RowBox[{
   RowBox[{"otherPeg", "[", 
    RowBox[{"C", ",", "B"}], "]"}], " ", ":=", " ", "A"}]}]], "Input",
 CellChangeTimes->{{3.592299087500053*^9, 3.592299096431284*^9}, {
  3.592307529044754*^9, 3.592307538260173*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"otherPeg", "[", 
    RowBox[{"C", ",", "A"}], "]"}], ":=", "B"}], ";", " ", 
  RowBox[{
   RowBox[{"otherPeg", "[", 
    RowBox[{"A", ",", "C"}], "]"}], " ", ":=", " ", "B"}]}]], "Input",
 CellChangeTimes->{{3.592299097621759*^9, 3.59229910123876*^9}, {
  3.59230753966017*^9, 3.592307572763173*^9}}],

Cell[CellGroupData[{

Cell["\<\
The inductive proof seen in the lecture that 2^n-1 moves are sufficient to \
move n discs becomes the code below\
\>", "Subsubsection",
 CellChangeTimes->{{3.592307583618081*^9, 3.592307668602311*^9}, {
  3.592308654731937*^9, 3.592308672336863*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"move", "[", 
    RowBox[{"1", ",", " ", "X_", ",", " ", "Y_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Print", "[", 
    RowBox[{
    "\"\<Move one disc from peg \>\"", ",", " ", "X", ",", " ", 
     "\"\< to peg \>\"", ",", " ", "Y"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5922991033433647`*^9, 3.5922992238007097`*^9}, {
  3.5922992932296124`*^9, 3.5922992936215553`*^9}, {3.592307552035907*^9, 
  3.592307555233273*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"move", "[", 
   RowBox[{"n_", ",", "X_", ",", "Y_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"move", "[", 
      RowBox[{
       RowBox[{"n", "-", "1"}], ",", "X", ",", 
       RowBox[{"otherPeg", "[", 
        RowBox[{"X", ",", "Y"}], "]"}]}], "]"}], ";", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"move", "[", 
      RowBox[{"1", ",", "X", ",", "Y"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"move", "[", 
      RowBox[{
       RowBox[{"n", "-", "1"}], ",", 
       RowBox[{"otherPeg", "[", 
        RowBox[{"X", ",", "Y"}], "]"}], ",", "Y"}], "]"}], ";"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5922991921857567`*^9, 3.592299207176774*^9}, {
  3.5922992954624147`*^9, 3.5922993593246603`*^9}, {3.592307553969103*^9, 
  3.5923075695328608`*^9}, {3.59230868459622*^9, 3.592308686519799*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Subsubsection",
 CellChangeTimes->{{3.592307899801364*^9, 3.592307900665092*^9}}],

Cell[BoxData[
 RowBox[{"move", "[", 
  RowBox[{"1", ",", "A", ",", "B"}], "]"}]], "Input",
 CellChangeTimes->{{3.5923079061620626`*^9, 3.5923079076330843`*^9}}],

Cell[BoxData[
 RowBox[{"move", "[", 
  RowBox[{"3", ",", "B", ",", "C"}], "]"}]], "Input",
 CellChangeTimes->{{3.592307908748376*^9, 3.5923079284400587`*^9}}],

Cell[BoxData[
 RowBox[{"move", "[", 
  RowBox[{"10", ",", "A", ",", "B"}], "]"}]], "Input",
 CellChangeTimes->{{3.592307919741159*^9, 3.5923079323438997`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Infinitely many primes (Theorem 5.6)\
\>", "Section",
 CellChangeTimes->{{3.6242732486140213`*^9, 3.6242732677864037`*^9}}],

Cell[BoxData[
 RowBox[{"PrimeNumbers", " ", ":=", " ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Prime", "[", "m", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", "1", ",", "25"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.624273578485538*^9, 3.62427365178916*^9}}],

Cell[CellGroupData[{

Cell[BoxData["PrimeNumbers"], "Input",
 CellChangeTimes->{{3.624273642585606*^9, 3.624273643761758*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "3", ",", "5", ",", "7", ",", "11", ",", "13", ",", "17", ",", 
   "19", ",", "23", ",", "29", ",", "31", ",", "37", ",", "41", ",", "43", 
   ",", "47", ",", "53", ",", "59", ",", "61", ",", "67", ",", "71", ",", 
   "73", ",", "79", ",", "83", ",", "89", ",", "97"}], "}"}]], "Output",
 CellChangeTimes->{{3.624273644109311*^9, 3.624273653171524*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"NN", "[", "ps_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Apply", "[", 
    RowBox[{"Times", ",", "ps"}], "]"}], "+", "1"}]}]], "Input",
 CellChangeTimes->{{3.6242736605610743`*^9, 3.624273687329273*^9}}],

Cell[CellGroupData[{

Cell["\<\
In small cases the number p_1...p_n +1 in Euclid\[CloseCurlyQuote]s proof is \
always prime. But when n=6 it is 59*509 which is not prime, and in fact the \
next time it is prime is when n=11.\
\>", "Subsubsection",
 CellChangeTimes->{{3.624273704941352*^9, 3.624273726519911*^9}, {
  3.624273827130509*^9, 3.624273846012385*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Euclid", "[", "n_", "]"}], ":=", 
  RowBox[{"NN", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PrimeNumbers", "[", 
      RowBox[{"[", "j", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", "n"}], "}"}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.624273691240893*^9, 3.624273773937599*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TableForm", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", 
       RowBox[{"Euclid", "[", "n", "]"}], ",", 
       RowBox[{"FactorInteger", "[", 
        RowBox[{"Euclid", "[", "n", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "1", ",", "15"}], "}"}]}], "]"}], ",", 
   RowBox[{"TableDepth", "\[Rule]", "2"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.624273751293559*^9, 3.624273816570225*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "3", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1"}], "}"}], "}"}]},
    {"2", "7", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"7", ",", "1"}], "}"}], "}"}]},
    {"3", "31", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"31", ",", "1"}], "}"}], "}"}]},
    {"4", "211", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"211", ",", "1"}], "}"}], "}"}]},
    {"5", "2311", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"2311", ",", "1"}], "}"}], "}"}]},
    {"6", "30031", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"59", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"509", ",", "1"}], "}"}]}], "}"}]},
    {"7", "510511", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"19", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"97", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"277", ",", "1"}], "}"}]}], "}"}]},
    {"8", "9699691", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"347", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"27953", ",", "1"}], "}"}]}], "}"}]},
    {"9", "223092871", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"317", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"703763", ",", "1"}], "}"}]}], "}"}]},
    {"10", "6469693231", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"331", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"571", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"34231", ",", "1"}], "}"}]}], "}"}]},
    {"11", "200560490131", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"200560490131", ",", "1"}], "}"}], "}"}]},
    {"12", "7420738134811", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"181", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"60611", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"676421", ",", "1"}], "}"}]}], "}"}]},
    {"13", "304250263527211", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"61", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"450451", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"11072701", ",", "1"}], "}"}]}], "}"}]},
    {"14", "13082761331670031", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"167", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"78339888213593", ",", "1"}], "}"}]}], "}"}]},
    {"15", "614889782588491411", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"953", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"46727", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"13808181181", ",", "1"}], "}"}]}], "}"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$, TableDepth -> 2]]]], "Output",
 CellChangeTimes->{{3.624273785302578*^9, 3.624273816826151*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
ScreenStyleEnvironment->"Presentation",
WindowSize->{1134, 744},
WindowMargins->{{41, Automatic}, {0, Automatic}},
ShowSelection->True,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 140, 2, 113, "Section"],
Cell[722, 26, 351, 9, 47, "Input"],
Cell[1076, 37, 349, 9, 47, "Input"],
Cell[1428, 48, 347, 9, 47, "Input"],
Cell[CellGroupData[{
Cell[1800, 61, 260, 5, 72, "Subsubsection"],
Cell[2063, 68, 478, 11, 78, "Input"],
Cell[2544, 81, 953, 24, 138, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3534, 110, 99, 1, 42, "Subsubsection"],
Cell[3636, 113, 160, 3, 47, "Input"],
Cell[3799, 118, 158, 3, 47, "Input"],
Cell[3960, 123, 159, 3, 47, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4168, 132, 133, 3, 113, "Section"],
Cell[4304, 137, 288, 7, 47, "Input"],
Cell[CellGroupData[{
Cell[4617, 148, 104, 1, 47, "Input"],
Cell[4724, 151, 405, 7, 78, "Output"]
}, Open  ]],
Cell[5144, 161, 235, 6, 47, "Input"],
Cell[CellGroupData[{
Cell[5404, 171, 340, 6, 72, "Subsubsection"],
Cell[5747, 179, 369, 10, 47, "Input"],
Cell[CellGroupData[{
Cell[6141, 193, 497, 13, 78, "Input"],
Cell[6641, 208, 3438, 112, 500, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
